#! /mnt/sdcard/execute/microperl
################################################################################
# Executor Helper - Version 1.2 - joghurt(at)southparkkillers.de
# Helps write own stuff for TTG by handling the boot/suspend/resume-Stuff.
#
# Installation: Extract package and copy it onto your SD card, root directory
#  so that "ttn" is directly in the root directory.
#
# Usage: Create your script that will be executed on boot/suspend/resume with
#  the parameter "BOOT", "SUSPEND" or "RESUME" and put it into the execute
#  directory in your root directory.
#  You can also put a directory with the same name there, it will also be
#  copied into the memory once on boot-time (system can load faster from there).
#
# I am using TTG v5.420, but I think this will work with older versions, too...?
#
# WARNING: Make sure, this scripts uses UNIX newline format! (aka "just LF")
# You better don't edit here if you don't know what this means, just use it...;)
#
# Thanks to amacri(at)tiscali.it for Event_Logger
################################################################################
#- Main Part -
$|=1;

#- Copy -
system("mkdir -p /opt");				# Create directory
system("cp -r /mnt/sdcard/execute /opt/");	# Much faster when executed

#- List -
opendir(a,"/opt/execute") || die "ARGH: $!";		# Read directory
@exec = grep {!/^microperl$/} grep {!/^\.+$/ && -f "/opt/execute/$_"} readdir(a);
closedir(a);

#- Inject execute-Files into rc.* -
undef $/;					# Remove line terminator
foreach $file ("boot","suspend","resume") {
  if (open(a,"/etc/rc.$file")) {
    $rows = <a>;
    close(a);
  } else {
    $rows = "#!/bin/sh\n\n";
  }

  foreach $exec(@exec) {
    $rows =~ s!^(.*?\n)!$1."/opt/execute/$exec ".uc($file)." >>/mnt/sdcard/Debug.log 2>&1 &\n".$2!esm;
  }

  open(a,">/etc/rc.$file");
  print a $rows;
  close(a);
  chmod 0755, "/etc/rc.$file";
}

################################################################################
